; 
    .686p                       ; create 32 bit code
    .XMM  ; SSE / SSE2 , 3D now, MMX 

    
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\user32.inc


    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\user32.lib

    include \masm32\macros\macros.asm
    include \masm32\include\timers.asm


    OemToCharBuffA PROTO :DWORD, :DWORD, :DWORD
    CharUpperBuffA PROTO :DWORD, :DWORD
    CharTranslate PROTO :DWORD, :DWORD, :DWORD
    GetAnsiToAsciiTab PROTO
    GetAnsiUpperTab PROTO

    .data
      str1 db "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"      
      str2 db "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"      
      pTable dd 0
    .code
; 
start: 

   invoke GetAnsiToAsciiTab
   mov pTable, eax

      print chr$(" OemToChar : ", 13,10)

;############################################################
      counter_begin 1000000, REALTIME_PRIORITY_CLASS
      invoke CharTranslate, pTable, ADDR str1, 60
      counter_end
      print ustr$(eax)
      print chr$(" cycles  CharTranslate", 13,10)
;############################################################
                              

;############################################################
      counter_begin 1000000, REALTIME_PRIORITY_CLASS
      invoke OemToCharBuffA, ADDR str1, ADDR str2, 60
      counter_end
      print ustr$(eax)
      print chr$(" cycles  API ", 13, 10, 10)
;############################################################
               

      print chr$(" CharUpperBuff : ", 13,10)

  

   invoke GetAnsiUpperTab
   mov pTable, eax

;############################################################
      counter_begin 1000000, REALTIME_PRIORITY_CLASS
      invoke CharTranslate, pTable, ADDR str1, 60
      counter_end
      print ustr$(eax)
      print chr$(" cycles  CharTranslate", 13,10)
;############################################################
               
               

;############################################################
      counter_begin 1000000, REALTIME_PRIORITY_CLASS
      invoke CharUpperBuffA, ADDR str1, 60
      counter_end
      print ustr$(eax)
      print chr$(" cycles  API ", 13, 10)
;############################################################
               

  
    mov   eax, input(13,10,"Press enter to exit...")


    exit
; 
end start
